code_start = $1001

.org code_start-2
	.word code_start; for the .prg file

;BASIC:	 2003 sys4109

	.word :+,2003
	.byte $9e	; sys token
	.byte "4109"
:	.byte 0,0,0


.proc	main

	sei
	sta $ff3f

	lda #0
	sta $ff15
	sta $ff19

	jsr copyFliData
	jsr initFli

c:	jmp c

.endproc


.proc	copyFliData

	lda #<fliData
	sta $d0
	lda #($3f + >fliData)
	sta $d1
	ldy #0
	sty $d2
	lda #$7f
	sta $d3
	ldx #$40
l:	lda ($d0),y
	sta ($d2),y
	iny
	bne l
	dec $d1
	dec $d3
	dex
	bne l
	rts
.endproc


.proc	initFli

	lda #$18
	sta $ff12

	lda #<irq
	sta $fffe
	lda #>irq
	sta $ffff
	lda #2
	sta $ff0a
	sta $ff0b
	lda $ff09
	sta $ff09
	cli
	rts


gr_mode_06 = $38

sc0 = $40
sc1 = $48
sc2 = $50
sc3 = $58

screens:
	.byte sc1,sc2,sc3,sc0

yscroll:
	.byte gr_mode_06 + 5
	.byte gr_mode_06 + 7
	.byte gr_mode_06 + 1
	.byte gr_mode_06 + 3


irq:
	sta tempa

	lda $ff1e
	and #4
	beq cont
cont:
	lda $ff09
	sta $ff09
	inc $ff0b
	lda #<timed
	sta $fffe
	cli
	stx tempx
	sty tempy
	ldx #0

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
tempa = *+1
	lda #0
tempx = *+1
	ldx #0
tempy = *+1
	ldy #0
	rti


timed = flic+5
flic:
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp $ea

	nop

	txa
	and #3
	tay

	lda screens,y
	sta $ff14
	lda yscroll,y
	sta $ff06
	inx
	cpx #100
	bne flic

out:
	dec $ff0b
	lda #<irq
	sta $fffe
	lda $ff09
	sta $ff09
	rti

.endproc


fliData:
